//
// Proxy classes for accessing ARB program parameters
//
// Author: Alex V. Boreskoff <alexboreskoff@mtu-net.ru>,<steps3d@narod.ru>
//

#include	"ParamProxy.h"

///////////////////////////// ParamProxy methods /////////////////////////////

ParamProxy :: ParamProxy ( PutFunc put, GetFunc get, GLenum theTarget, int theIndex )
{
	getter = get;
	putter = put;
	target = theTarget;
	index  = theIndex;
}

void ParamProxy :: operator = ( const Vector4D& v )
{
	putter ( target, index, v );
}

void ParamProxy :: operator = ( const Vector3D& v )
{
	Vector4D	  v1 ( v );

	putter ( target, index, v1 );
}

ParamProxy :: operator Vector4D	() const
{
	Vector4D	v;

	getter ( target, index, v );

	return v;
}

///////////////////////////// ParamArray methods /////////////////////////////

ParamArray :: ParamArray ( GLenum theTarget )
{
	getter = NULL;
	putter = NULL;
	target = theTarget;
}

void	ParamArray :: setPointers ( ParamProxy :: PutFunc put, ParamProxy :: GetFunc get )
{
	getter = get;
	putter = put;
}

